/* LABORATORIO DI ALGORITMI
	
	gruppo LAUREA 01
	
	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828


File liste.h: contiene l'interfaccia della struttura dati LISTE*/

#ifndef LISTE_H
#define LISTE_H
#include <stdio.h>
#include "local.h"




/*	Abbiamo riutilizzato il codice che gestiva delle liste scritto per un
	eserrfizio precedente, per evitare rinomine, non etichetteremo i nostri dati come "* void" 
	ma ridefiniamo il dato delvecchio codice come generico, risuteranno i seguenti alias:
		void *
		generico
		dato
	le nuove procedure, proprie delle liste generiche, lavoreranno su tipi generici
	mentre quelle vecchie lavoreranno su tipi dato il tutto funziona grazie al controllo
	dei tipi statico-struttarale dei compilatori c.
	Ove necessario abbiamo apportato delle modifiche al vecchio codice, specialmente nelle funzioni
	che rilasciano memoria al sistema, cio' e dovuto al fatto che ora occore rilasciare anche la memoria
	puntata da elem. 
*/

typedef void * generico;


/* Tipi */
typedef generico dato; // unica modifica apportate alle liste del precedente esercizio

typedef struct nodolista * lista;
struct  nodolista {
	dato elem;
	lista next;
	};

/* Prototipi*/

status makelista (lista *p_L);
/*Inizializza in p_L una lista vuota*/

bool controlla_lista_vuota(lista L);
/*Controlla la presenza di almeno un elemento nella lista */

status inserisci_in_testa (lista *p_L, dato d);
/*Inserisce in testa alla lista puntata da p_L un nodo contenente l'elemento*/

status cancella_in_testa (lista *p_L, dato *d);
/*Cancella il primo nodo della lista puntata da p_L e ne assegna l'elemento dato a d*/

status inserisci_in_coda (lista *p_L, dato d);
/*Inserisce in coda alla lista puntata da p_L un nodo contenente l'elemento d*/

status cancella_nodo (lista *p_L, lista nodo);
/*Cancella dalla lista puntata da p_L, il nodo puntato da nodo*/

lista trova (lista L, dato d, int (*comp)(const void *a,const void *b) );
/*Restituisce  il puntatore al primo nodo della lista L contenete l'elemento d se esiste, NULL altrimenti*/

void cancella_lista (lista *p_L);
/*Cancella tutta la lista puntata da p_L*/

lista leggilista (void);
/*Legge una lista di dati di tipo dato da tastiera*/

status inserisci_ordinato(lista *p_L,generico dato, int (*pf)(generico,generico));
/*Inserisce nella lista un elemento secondo l'ordinamento che gli passiamo noi*/

void applica_tutti(lista p_L, void (*pf)(generico));
/*Applica a tutti gli elementi della lista la funzione passata come parametro*/


#endif
