/* LABORATORIO DI ALGORITMI

	gruppo LAUREA 01

	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828
*/




#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>


#include "local.h"
#include "grafi.h"


#include "fifo.h"



#define ESC  27
#define UP   72
#define DOWN 80
#define LEFT 75
#define RIGHT 77
#define SPACE 32
#define step  14
#define MAX_NODI  10
#define MAX_ARCHI 10
#define NODE	  0
#define from_x    1
#define to_y	  2
#define delta	9



char *stato[3]={ "Posizionare i vertici con SPACE  ESC per finire","Selezionare il nodo di partenza con SPACE ESC per finire", "nodo di arrivo ? ESC per finire"};

int x,y,numero_nodi,num_arc,cursore=NODE;
int mx,my,mcolor,v;
char s[10];

int nodi[MAX_NODI][2];
int archi[MAX_ARCHI][2];
bool *foglia;
int  *distanza;
int  *radice;
int  *colore;


void draw_graph();

void stampa_archi_uscenti(graph G,vertex v, vertex start)
{
	edge *cur = NULL;

	while ( (cur = edge_iterator(G,v,cur)) != NULL)
		if ( ((int)(VERTEX(cur))) >= ((int)start) )
			printf("L'arco da %d a %d ha peso:%d\n",(int)v,VERTEX(cur),WEIGHT(cur));
}

void stampa_grafo(graph G)
{
	int ji;

	if (G != NULL) {
		if (G->type == directed)
			for (ji = 0; ji< G->number_of_vertices; ji++)
				stampa_archi_uscenti(G,(vertex) ji,(vertex) 0);
		else
			for (ji = 0; ji< G->number_of_vertices; ji++) {
			printf("stampo archi di %d\n",ji);
			stampa_archi_uscenti(G,(vertex) ji, (vertex)ji);
			}
	}
	else printf("Il grafo e' vuoto\n");
}




void bfs(graph G,int s,bool *foglia,int  *distanza,	int  *radice,int  *colore)
{
vertex v,u;
edge   *cur;
fifo	f;
int *t;
crea_coda_vuota(&f);
colore[s]   = GRIGIO;
distanza[s] = 0;
radice[s]   = s;

t=(int *)malloc(sizeof(int));
*t=s;
inserisci(&f,t);

while (controlla_coda_vuota(f)==FALSE)
{
estrai_testa(&f,(void **)&t);

u = *t;
cur = NULL;

while ( (cur = edge_iterator(G,u,cur)) != NULL)
		 {   v = VERTEX(cur);
	      if (colore[v] == BIANCO  )
		  {

		  colore[v]   = GRIGIO;
		  distanza[v] = distanza[u]+1;
		  radice[v]   = s;
		  foglia[u]   = FALSE;

		  setlinestyle(SOLID_LINE,1,3);
		  setcolor(RED);
		  line(nodi[v][0],nodi[v][1],nodi[u][0],nodi[u][1]);

		  setlinestyle(SOLID_LINE,1,1);
		  draw_graph();
		  getch();


		t=(int *)malloc(sizeof(int));
		*t=v;
		inserisci(&f,t);
		  }
	 }
  /* elimina_in_testa  non occorre se gia fatto da estrai testa */
  colore[u]=NERO;
  draw_graph();
  getch();



}

distruggi_coda(&f);
}

void total_bfs(graph G,bool *foglia,int  *distanza,	int  *radice,int  *colore)
{
int i;

	for (i=0;i<G->number_of_vertices; i++)
	{
		foglia[i]  = TRUE;
		distanza[i]= UNUSED_WEIGHT;
		radice[i]  = i;
		colore[i]  = BIANCO;
	}

	for (i=0;i<G->number_of_vertices; i++)
		if (colore[i]==BIANCO)
			bfs(G,i,foglia,distanza,radice,colore);

}



int approxv()
{
 int i;

 for (i=numero_nodi;i>=0;i--)
	if( abs(nodi[i][0]-x)< delta && abs(nodi[i][1]-y) < delta)
		break;
 return i;
}

void draw_graph()
{

 int i;

 setcolor(WHITE);

 for (i=0;i<num_arc;i++)
       line(nodi[archi[i][0]][0],nodi[archi[i][0]][1],nodi[archi[i][1]][0],nodi[archi[i][1]][1]);


 if(colore==NULL)
  {
  setfillstyle(SOLID_FILL,WHITE);
  for (i=0;i<numero_nodi;i++)
	pieslice(nodi[i][0],nodi[i][1],0, 360, 10);
  }
 else
 for (i=0;i<numero_nodi;i++)
	{int col;
	if (colore[i]==BIANCO)
	   col=WHITE;
	else
	if (colore[i]==GRIGIO)
	   col=LIGHTGRAY;
	else col=BLACK;

	setfillstyle(SOLID_FILL,col);
	pieslice(nodi[i][0],nodi[i][1],0, 360, 10);

	}

 setcolor(RED);

 for (i=0;i<numero_nodi;i++)
	outtextxy(nodi[i][0]-3,nodi[i][1]-3,itoa(i,s,10));

 setcolor(WHITE);

}


void update()
{

clearviewport();
draw_graph();
if (cursore == NODE)
 circle(x,y,10);
else
if (cursore == to_y)
  line(nodi[archi[num_arc][0]][0],nodi[archi[num_arc][0]][1],x,y);
else
 circle(x,y,4);

outtextxy(0,my-7,stato[cursore] );
outtextxy(500,my-7,itoa(numero_nodi,s,10) );
outtextxy(540,my-7,itoa(num_arc,s,10) );
}

int main(void)
{
int c;

graph G;
int vertex_number, arc_number,i;



   /* request auto detection */
   int gdriver = DETECT, gmode, errorcode;

   /* initialize graphics mode */
   initgraph(&gdriver, &gmode, "");

   /* read result of initialization */
   errorcode = graphresult();

   if (errorcode != grOk)  /* an error occurred */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1);             /* return with error code */
   }

   moveto(0,0);
   mcolor=getmaxcolor();
   mx=getmaxx();
   my=getmaxy();

  x=34;y=100;
  update();

  while(cursore != ESC)
    {

    c=getch();
    switch (c)
     {
     case 0: break;
     case ESC:     if(cursore == NODE) cursore = from_x;
		    else  cursore = ESC;
     case UP: 	   if(y<0) y=my; else y-=step; update();	break;
     case DOWN:    if(y>my) y=0; else y+=step; update();     	break;
     case RIGHT:   if(x>mx) x=0; else x+=step; update();	break;
     case LEFT:	   if(x<0) x=mx; else x-=step; update();	break;
     case SPACE:
		if (cursore == NODE)
		      {
			nodi[numero_nodi][0]=x;nodi[numero_nodi++][1]=y;
			if(numero_nodi >= MAX_NODI)
			  cursore = from_x;

			update();
			}
		   else
		if (cursore == from_x)

		     {
		       if( (v = approxv()) >= 0 ) // e' un vertice valido
			{
			 cursore = to_y;
			 archi[num_arc][0]=v;
			 update();
			}

		     }

		   else
		if (cursore == to_y)
		      {
		       if( (v = approxv()) >= 0 ) // e' un vertice valido
			{
			 if(v!=archi[num_arc][0]) // niente cappi per adesso
			 {
			 cursore = from_x;
			 archi[num_arc][1]=v;
			 num_arc++;
			 }
			}

		       }

		if(num_arc >= MAX_ARCHI)
			{

			cursore = ESC;
			    }


			break;
      }
    }

	clearviewport();
	draw_graph();

	if(init_graph(&G,numero_nodi,undirected)==ERROR)
	  printf("Errore nell' init_graph\n");

	for(i=0;i<num_arc;i++)
	   if(add_edge(G,(vertex)archi[i][0],(vertex)archi[i][1],1)==ERROR)
		 printf("Errore nell' adding edge %d\n",i);






	foglia	= malloc(vertex_number*sizeof( bool ));
	distanza= malloc(vertex_number*sizeof( int ));
	radice	= malloc(vertex_number*sizeof( int ));
	colore	= malloc(vertex_number*sizeof( int ));


	total_bfs(G,foglia,distanza,radice,colore);


 for (i=0;i<numero_nodi;i++)
	if(foglia[i]==TRUE)
	 {
	 setcolor(GREEN);
	 circle(nodi[i][0],nodi[i][1], 13);
	 circle(nodi[i][0],nodi[i][1], 12);
	 }
 for (i=0;i<numero_nodi;i++)
 {
  setfillstyle(SOLID_FILL,BLACK);
  pieslice(nodi[i][0],nodi[i][1],0, 360, 10);
  }

 setcolor(RED);

 for (i=0;i<numero_nodi;i++)
	outtextxy(nodi[i][0]-3,nodi[i][1]-3,itoa(distanza[i],s,10));


	getch();
	clearviewport();

	closegraph();


    /*	stampa_grafo(G);
	graph_size(G,&vertex_number,&arc_number);
	printf("Il grafo ha %d vertic%c e %d arc%s\n",vertex_number,(vertex_number ==1)? 'e':'i',arc_number,(arc_number == 1)? "o":"hi");

	for (i = 0; i< G->number_of_vertices; i++) {
			printf("Nell'albero di visita, la radice del vertice %d che dista %d e' %d\n",i,distanza[i],radice[i]);
			printf("il vertice %d %s una foglia dell' albero di visita\n",i,(foglia[i]==TRUE )? "e'":"non e'");
			}
    */


    /*   Libero le risorse   */

	free(foglia);
	free(distanza);
	free(radice);
	free(colore);

	destroy_graph(&G);




      return 0;
}

