
typedef int vertex;

typedef struct {
	vertex vertex_number;
	int weight;
} edge;

#define WEIGHT(p_e)	((p_e)->weight)
#define VERTEX(p_e)	((p_e)->vertex_number)
#define UNUSED_WEIGHT (32767)

typedef enum {directed, undirected} graph_type;

typedef struct{
	graph_type type;
	int number_of_vertices;
	edge ** matrix; /* edge matrix[][] */
} graph_header, *graph;

status init_graph(graph *p_G, int vertex_cnt, graph_type type);
void destroy_graph(graph *p_G);
status add_edge(graph G, vertex vertex1, vertex vertex2, int weight);
status delete_edge(graph G, vertex vertex1, vertex vertex2);
bool is_adjacent(graph G, vertex vertex1, vertex vertex2);
void graph_size(graph G, int *p_vertex_cnt, int *p_edge_cnt);
edge *edge_iterator(graph G, vertex vertex_number, edge	*p_last_return);
