/* LABORATORIO DI ALGORITMI
	
	gruppo LAUREA 01
	
	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828
*/

#include <stdio.h>
#include <stdlib.h>
#include "local.h"
#include "grafi.h"



/*	le seguenti variabili le dichiariamo globali per uniformita' di notazione con il libro di testo */

int		*d;		// vettore delle distanze
vertex  *pi;	// pettore dei predecessori

#define NIL -1

void Print_Path(vertex s,vertex v)
{
	if (v == s)
		printf(" %d ",s);
	else
		if (pi[v]== NIL)
			printf(" inesistente da %d al %d\n",s,v);
		else
		{
			Print_Path(s,pi[v]);
			printf(" %d ",v);
		}
}


void Initialize_Single_Source(graph G,vertex s)
{
	int i,vertex_number;
	graph_size(G,&vertex_number,&i);
	for (i=0;i<vertex_number;i++)
	{
		d[i] = UNUSED_WEIGHT;
		pi[i]= NIL;
	}
  d[s]=0;	

}

void Relax(vertex u,vertex v,int w)
{
	if(d[v]>d[u]+w)
	{
		d[v] = d[u] + w;
	    pi[v]= u;
	}
}


bool Belmann_Ford(graph G,vertex s)
{


	typedef struct coppia_v { vertex u,v;
								int w;} arco;

	arco *archi;
	edge *cur;

	int i,j,vertex_number,edge_number;

	Initialize_Single_Source(G,s);
	graph_size(G,&vertex_number,&edge_number);

	archi=malloc(sizeof(arco)*edge_number); // alloco un vettore di archi
	j = 0;
	for (i=0; i<vertex_number;i++)	
	{
	cur=NULL;
	while(( cur = edge_iterator(G,i,cur)) != NULL)
			{
			archi[j].u = i;				// memorizzo il vertice di partenza
			archi[j].v = VERTEX(cur);	// memorizzo il vertice di arrivo
			archi[j].w = WEIGHT(cur);		
			j++;
			}
		}
	 


#define w archi[j].w
#define u archi[j].u
#define v archi[j].v


	for (i=1; i<vertex_number;i++)	
		for (j=0; j<edge_number;j++)	// per ogni arco (u,v) di G
		    Relax(u,v,w);
		
	for (j=0; j<edge_number;j++)	   // per ogni arco (u,v) di G
		if( d[v]>d[u]+w )
			{
			free(archi);
			return 	FALSE; 
			}
free(archi);
return TRUE;	

#undef u
#undef v
#undef w   

}



/******************************* Procedure di immisione Grafo **********************************************/

status costrusci_archi_uscenti(graph G,vertex v,vertex start)
{
	int i, peso;
	char risp;
	status rc;

	for (i = (int) start; i< G->number_of_vertices; i++) {
		printf("\nC'e' un arco dal vertice %d al vertice %d?(Y/N):",(int)v,i);
		risp=toupper( getchar());
		getchar();
		
		if (risp == 'Y') {
			printf("\nPeso dell'arco:");
			scanf("%d",&peso); 
			getchar(); 
		    rc = add_edge(G,v,(vertex)i,peso);
			if (rc == ERROR) return ERROR;
		}
		
	}
 return OK;
}

status leggi_grafo(graph *p_G)
{
	int vert_num, i;
	graph_type tgrafo;
	status rc;
/*
	printf("\nTipo del Grafo (D per diretto, U per non diretto):");
	
	tipo=toupper( getchar());
	
	if (tipo == 'D')
		tgrafo = directed;
	else
		if (tipo == 'U')
			tgrafo = undirected;
		else return ERROR;
*/
	tgrafo = directed;	// per Bellman-Ford vogliamo solo Grafi Orientati

	printf("\nNumero dei vertici del Grafo:");

	scanf("%d", &vert_num);
	getchar();

	if (vert_num <= 0)
		return ERROR;

	init_graph(p_G,vert_num,tgrafo);

	if (tgrafo == directed)
		for (i = 0; i< (*p_G)->number_of_vertices; i++) {
			rc = costrusci_archi_uscenti((*p_G),(vertex) i,
							(vertex) 0);
			if (rc == ERROR) return ERROR;
		}
	else
		for (i = 0; i< (*p_G)->number_of_vertices; i++) {
			rc = costrusci_archi_uscenti((*p_G),(vertex) i,(vertex) i+1);
			if (rc == ERROR) return ERROR;
		}
 return OK;
}

void stampa_archi_uscenti(graph G,vertex v, vertex start)
{
	edge *cur = NULL;

	while ( (cur = edge_iterator(G,v,cur)) != NULL)
		if ( ((int)(VERTEX(cur))) >= ((int)start) )
			printf("L'arco da %d a %d ha peso:%d\n",(int)v,VERTEX(cur),WEIGHT(cur));
}

void stampa_grafo(graph G)
{
	int i;

	if (G != NULL) {
		if (G->type == directed)
			for (i = 0; i< G->number_of_vertices; i++)
				stampa_archi_uscenti(G,(vertex) i,(vertex) 0);
		else
			for (i = 0; i< G->number_of_vertices; i++) {
			printf("stampo archi di %d\n",i);
			stampa_archi_uscenti(G,(vertex) i, (vertex)i);
			}
	}
	else printf("Il grafo e' vuoto\n");
}

void main ()
{
	char buff[10];
	graph G;
	status rc;
	vertex s;
	int vertex_number,edge_number,i;

	rc = leggi_grafo(&G);
	if (rc == ERROR)
		{
		printf("ERRORE NELLA COSTRUZIONE DEL GRAFO\n");
		exit(0);
		}



/*
if(init_graph(&G,6,directed)==OK)  // esmpio di grafo orientato
{
add_edge(G,0,1,6);
add_edge(G,0,3,7);
add_edge(G,1,2,5);
add_edge(G,1,4,-4);
add_edge(G,1,3,8);
add_edge(G,2,1,-2);
add_edge(G,3,2,-3);
add_edge(G,3,4,9);
add_edge(G,4,0,2);
add_edge(G,4,2,7);

add_edge(G,6,0,7);

}
else {
	printf("Errore in fase di inizializzazione del grafo\n");
	exit(0);
}

 */

	stampa_grafo(G);


	graph_size(G,&vertex_number,&edge_number);

	d = malloc(vertex_number * sizeof(int));
	pi= malloc(vertex_number * sizeof(int));
	if ((d == NULL) || (pi == NULL))
	{
		printf("Impossibile allocare memoria !\n");
		destroy_graph(&G);
		exit(0);
	}
	
  do
  {
	printf("Inserire il vertice sorgente :");
	scanf("%d",&s);
  }
  while ((s<0) || (s>=vertex_number));

	if( Belmann_Ford(G,s) == TRUE)
	{
		printf("Cammini minimi da %d\n",s);
		for(i=0;i<vertex_number;i++)
			if(i!=s)
			{
				printf("Il vertice %d dista %s da s con cammino",i,(d[i]==UNUSED_WEIGHT)? "Infinito":itoa(d[i],buff,10));
				Print_Path(s,i);
				printf("\n");
			}
	}
				
	else
	  printf("C'e' un ciclo negativo !\n");

	destroy_graph(&G);

}
