/* LABORATORIO DI ALGORITMI
	
	gruppo LAUREA 01
	
	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828
*/

#include <stdio.h>
#include <stdlib.h>
#include "local.h"
#include "grafi.h"

#include "fifo.h"


status costrusci_archi_uscenti(graph G,vertex v,vertex start)
{
	int i, peso;
	char risp;
	status rc;

	for (i = (int) start; i< G->number_of_vertices; i++) {
		printf("\nC'e' un arco dal vertice %d al vertice %d?(Y/N):",(int)v,i);
		risp=toupper( getchar());
		getchar();
		
		if (risp == 'Y') {
//			printf("\nPeso dell'arco:");
//			scanf("%d",&peso); 
//			getchar(); 
		    peso = 1; // per i grafi non pesati
			rc = add_edge(G,v,(vertex)i,peso);
			if (rc == ERROR) return ERROR;
		}
		
	}
 return OK;
}

status leggi_grafo(graph *p_G)
{
	int vert_num, i;
	char tipo;
	graph_type tgrafo;
	status rc;

	printf("\nTipo del Grafo (D per diretto, U per non diretto):");
	
	tipo=toupper( getchar());
	
	if (tipo == 'D')
		tgrafo = directed;
	else
		if (tipo == 'U')
			tgrafo = undirected;
		else return ERROR;

	printf("\nNumero dei vertici del Grafo:");

	scanf("%d", &vert_num);
	getchar();

	if (vert_num <= 0)
		return ERROR;

	init_graph(p_G,vert_num,tgrafo);

	if (tgrafo == directed)
		for (i = 0; i< (*p_G)->number_of_vertices; i++) {
			rc = costrusci_archi_uscenti((*p_G),(vertex) i,
							(vertex) 0);
			if (rc == ERROR) return ERROR;
		}
	else
		for (i = 0; i< (*p_G)->number_of_vertices; i++) {
			rc = costrusci_archi_uscenti((*p_G),(vertex) i,(vertex) i+1);
			if (rc == ERROR) return ERROR;
		}
 return OK;
}

void stampa_archi_uscenti(graph G,vertex v, vertex start)
{
	edge *cur = NULL;

	while ( (cur = edge_iterator(G,v,cur)) != NULL)
		if ( ((int)(VERTEX(cur))) >= ((int)start) )
			printf("L'arco da %d a %d ha peso:%d\n",(int)v,VERTEX(cur),WEIGHT(cur));
}

void stampa_grafo(graph G)
{
	int i;

	if (G != NULL) {
		if (G->type == directed)
			for (i = 0; i< G->number_of_vertices; i++)
				stampa_archi_uscenti(G,(vertex) i,(vertex) 0);
		else
			for (i = 0; i< G->number_of_vertices; i++) {
			printf("stampo archi di %d\n",i);
			stampa_archi_uscenti(G,(vertex) i, (vertex)i);
			}
	}
	else printf("Il grafo e' vuoto\n");
}

void bfs(graph G,int s,bool *foglia,int  *distanza,	int  *radice,int  *colore)
{
vertex v,u;
edge   *cur;
fifo	f;
int *t;
crea_coda_vuota(&f);
colore[s]   = GRAY;
distanza[s] = 0;
radice[s]   = s;

t=(int *)malloc(sizeof(int));
*t=s;
inserisci(&f,t);

while (controlla_coda_vuota(f)==FALSE)
{
estrai_testa(&f,(void **)&t);

u = *t;
cur = NULL;

while ( (cur = edge_iterator(G,u,cur)) != NULL)
		 {   v = VERTEX(cur);
			if (colore[v] == WHITE  )
			{
				colore[v]   =  GRAY;
				distanza[v] = distanza[u]+1;
				radice[v]   = s;
				foglia[u]	= FALSE;
		  
		t=(int *)malloc(sizeof(int));
		*t=v;
		inserisci(&f,t);
		  }
	 }
  colore[u]=BLACK; 


}   // end while 

distruggi_coda(&f);
}

void total_bfs(graph G,bool *foglia,int  *distanza,	int  *radice,int  *colore)
{
int i;

	for (i=0;i<G->number_of_vertices; i++)
	{
		foglia[i]  = TRUE;
		distanza[i]= UNUSED_WEIGHT;
		radice[i]  = i;
		colore[i]  = WHITE;
	}
	
	for (i=0;i<G->number_of_vertices; i++)
		if (colore[i]==WHITE)
			bfs(G,i,foglia,distanza,radice,colore);

}


void main ()
{
	graph G;
	int vertex_number, arc_number,i;
	status rc;
	bool *foglia;
	int  *distanza;
	int  *radice;
	int  *colore;
	

/*	rc = leggi_grafo(&G);
	if (rc == ERROR)
		{
		printf("ERRORE NELLA COSTRUZIONE DEL GRAFO\n");
		exit(0);
		}

  */
	if(init_graph(&G,6,directed)==OK)  // case con grafo orientato
{
add_edge(G,0,1,1);
add_edge(G,0,3,1);
add_edge(G,1,2,1);
add_edge(G,1,4,1);
add_edge(G,1,3,1);
add_edge(G,2,1,1);
add_edge(G,3,2,1);	
add_edge(G,3,4,1);
add_edge(G,4,0,1);
add_edge(G,4,2,1);

add_edge(G,6,0,1);

}		 
else {
	printf("Errore in fase di inizializzazione del grafo\n");
	exit(0);
}

		

	graph_size(G,&vertex_number,&arc_number);
	printf("Il grafo ha %d vertic%c e %d arc%s\n",vertex_number,(vertex_number ==1)? 'e':'i',arc_number,(arc_number == 1)? "o":"hi");
    
	foglia	= malloc(vertex_number*sizeof( bool ));
	distanza= malloc(vertex_number*sizeof( int ));
	radice	= malloc(vertex_number*sizeof( int ));
	colore	= malloc(vertex_number*sizeof( int ));
	

	
	stampa_grafo(G);
	total_bfs(G,foglia,distanza,radice,colore);

	for (i = 0; i< G->number_of_vertices; i++) {
			printf("La radice del vertice %d che dista %d e' %d\n",i,distanza[i],radice[i]);
			printf("il vertice %d %s una foglia dell' albero di visita\n",i,(foglia[i]==TRUE )? "e'":"non e'");
			}
	/*   Libero le risorse   */

    free(foglia);
    free(distanza);
    free(radice);
    free(colore);

    destroy_graph(&G);
	

}
