/* LABORATORIO DI ALGORITMI
	
	gruppo LAUREA 01
	
	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828

	FILE LISTE.C
Implementa le funzioni richieste per la gestione del tipo lista.
E' presente anche una funzione di confronto tra interi usata da 
trova(). 
*/


#include "liste.h"
#include "local.h"
#include <stdio.h>
#include <stdlib.h>


status makelista(lista *p_L)
{
	*p_L=NULL;
	return OK;		
}


bool controlla_lista_vuota(lista L)
/*Controlla la presenza di almeno un elemento nella lista */
{
	if(L==NULL)
		return TRUE;
	return FALSE;
}


status inserisci_in_testa(lista *p_L, dato d)

{
	lista temp;
	temp=(lista)malloc(sizeof(struct nodolista));
	if (temp==NULL) return(ERROR);
	else
	{
		temp->elem=d;
		temp->next=*p_L;
		*p_L=temp;
		return OK;
	}
}


status inserisci_ordinato(lista *p_L,generico dato, int (*pf)(generico,generico))
/*Inserisce nella lista un elemento secondo l'ordinamento che gli passiamo noi*/
{
if(*p_L == NULL)
	return inserisci_in_testa(p_L,dato);
if ( pf(dato,(*p_L)->elem) <= 0)  // in ordine crescente
	return inserisci_in_testa(p_L,dato);
else
	return inserisci_ordinato(&(*p_L)->next,dato,pf);

}


status cancella_in_testa (lista *p_L, dato *d)
{

	lista garbage;
	garbage=*p_L;
	if (garbage==NULL) return(ERROR); // la lista e' vuota
	else
	{
		*d=(*p_L)->elem;
		*p_L=(*p_L)->next;
		free(garbage);
		return OK;
	}
}

status inserisci_in_coda (lista *p_L, dato d)
{
	if (*p_L==NULL) return(inserisci_in_testa(p_L,d));
	else return inserisci_in_coda(&((*p_L)->next),d);
}


status cancella_nodo(lista *p_L, lista nodo)
{
	while ( ((*p_L) !=NULL) && (*p_L != nodo) )
			p_L=&((*p_L)->next);

	if (*p_L==NULL)
		return ERROR;
	(*p_L)=(nodo->next);
	free(nodo->elem);			// aggiunta per gestire liste generiche
	free(nodo);
	return(OK);
}

lista trova (lista L, dato nodo, int (*pf)(const void *a,const void *b) )
//Restituisce  il puntatore al primo nodo della lista L contenete l'elemento d se esiste, NULL altrimenti
{

while ( L!=NULL && ( pf((void *)L->elem , (void *) nodo) !=0 )  )
	L=L->next;

return L;

}

void cancella_lista(lista *p_L)
/*Cancella tutta la lista puntata da p_L*/
{
lista t;
while( (t=*p_L) != NULL)
{
	*p_L=(*p_L)->next;
	free(t->elem);	
	free(t);
}

}

lista leggilista (void)
/*Legge una lista di dati di tipo dato da tastiera*/
{	int i;
	lista L;
	makelista(&L);
	printf("Immetti una lista di interi separati da spazio < q > per terminare\n");
	while(scanf("%d", &i  ))
		inserisci_in_coda (&L,(generico)i);
	
	return L;
}

void applica_tutti(lista L, void (*pf)(generico))
{
	while (L!=NULL)
		{ (*pf)(L->elem);
		L=L->next;
		}
}
