/* LABORATORIO DI ALGORITMI
	
	gruppo LAUREA 01
	
	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828
*/

/* Il file heap.h contiene i prototipi delle funzioni utilizzate da heap.c*/


#ifndef HEAP_H
#define HEAP_H


#include "local.h"


typedef struct elem {
		char *nome;  /* Per distinguere il nome dalla Priorita
				abbiamo usato delle stringhe per il nome */
		int priorita; } *dato;


typedef struct  {
		dato *vettore;
		int primalibera;
		int maxsize;	} heap;

#define ORD_REL <


void distruggi_dato(dato d);
/*	Rilascia la memoria allocata per dato  
	Questa procedura e stata aggiunta per rendere la gestione dello Heap
	Indipendente dal tipo di dato	*/

status makeheap(heap *h,int n);
/* Inizializza in *h uno heap vuoto che puo' contenere n elementi;
restituisce un valore status a seconda che l'operazione sia andata
a buon fine oppure no*/

status buildheap(heap *h);
/* Applica la proprieta' di heap ad *h*/

bool test_vuoto(heap h);
/* Controlla se h e' vuoto*/

status inserisci(heap *h, dato d);
/* Inserisce il dato d in *h al posto giusto: restituisce un valore status
a seconda che l'operazione sia andata a buon fine oppure no*/

status estrai_minimo(heap *h, dato *d);
/* Estrae il minimo dello heap che viene letto in *d modificando
opportunamente lo heap; restituisce un valore status a seconda che
l'operazione sia andata a buon fine oppure no*/

status minimo(heap h, dato *d);
/* Legge il minimo dello heap che viene letto in *d senza modificare lo heap;
restituisce un valore status a seconda che l'operazione sia andata a buon
fine oppure no (es. leggere il minimo di uno heap vuoto)*/

bool aggiorna(heap *h, int indice, int nuovapriorita);
/* Aggiorna la priorita dell'elemento di indice "indice" del vettore dello
heap a nuovapriorita se questa e' strettamente inferiore di quella
dell'elemento. Restituisce un valore booleano per indicare se la sostituzione
e' avvenuta o no. Osservare che lo heap e' passato per referenza anche se
di fatto la struttura heap non viene modificata*/

void heapify(heap *h, int i);
/* Mantiene le proprieta' dello heap */


/* per efficienza le seguenti funzioni sono state implementate con Macro

int parent(int i);
// Restituisce l'indice del padre del nodo di indice i
int left(int i);
// Restituisce l'indice del figlio sinistro del nodo con indice i
int right(int i);
// Restituisce l'indice del figlio destro del nodo con indice i

*/

#define parent(I)	(((I)-1)/2)
#define left(I)		(2*(I)+1)
#define right(I)	(2*((I)+1))

void swap(heap *h, int a, int i);
// E difficile realizzare una una macro per Swap
// Scambia i puntatori a due nodi dell'heap.

int find(heap h, dato d);
/* Cerca nel vettore che costituisce lo heap un elemento il cui campo nome
sia uguale a quello di dato. Se lo trova restituisce l'indice relativo del
vettore, altrimenti restituisce -1*/

void distruggi(heap *h);
/* Distrugge lo heap *h*/

void stampa(heap h);
/* Stampa il contenuto dello heap h*/
#endif